ScriptName InigoMCMScript extends SKI_ConfigBase
{renn's Tweak 2.3}

; CHANGES FOR MAIN SCRIPTS: improved whistle, property for horse speed

; POSSIBLE ADDITIONS: saddles, restart (some) quests, check for aliases on him (and try to clear them?)

; INVESTIGATE: sitting with player, detect swimming under water (not at surface)

; QUESTIONABLE: dedicated activate or other command keys


Function OnConfigInit()
	ModName = "INIGO"
	if !WhistleKeyCode
		WhistleKeyCode = 45 ; X is the default
		RegisterForKey(WhistleKeyCode)
	endif
EndFunction


Function OnPageReset(String a_page)
	if !InigoSteedAllowed ; fill these once
		InigoSteedAllowed = Game.GetFormFromFile(0x0A7538, "Inigo.esp") as FormList
		InigoStatus = Game.GetFormFromFile(0x09D37D, "Inigo.esp") as InigoStatusQuestScript
		Tamriel = Game.GetForm(0x3C)
		PlayerRef = Game.GetForm(0x14) as Actor
		InigoRef = Game.GetFormFromFile(0x008ae9, "Inigo.esp") as Actor
	endif
	if !InigoSteedAllowed ; no need to show the menu if it's not Inigo version 2.2
		AddHeaderOption("Couldn't find Inigo 2.2 or higher!")
	endif

	SteedRef = InigoStatus.SteedAlias.GetReference() as Actor  ; don't cache these because they change
	CurrentWorld = PlayerRef.GetWorldSpace()
	if !CurrentWorld
		CurrentWorld = PlayerRef.GetParentCell()
	endif
	IsSteedAllowedHere = CurrentWorld && InigoSteedAllowed && InigoSteedAllowed.HasForm(CurrentWorld)
	MrDVisible = GetAlias(1) as MrDVisibleScript
	
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddKeyMapOptionST("Whistle", "Whistle Hotkey", WhistleKeyCode, OPTION_FLAG_WITH_UNMAP)
	AddTextOptionST("ShowMrD", "Show Mr Dragonfly", ShowMrDTxt(MrDVisible.ShowMrD))
	SetCursorPosition(1)
	AddToggleOptionST("SteedAllowed", "Steed Allowed Here", IsSteedAllowedHere)
	if SteedRef
		AddSliderOptionST("SteedSpeedMult", "Trusty Steed's Speed", SteedRef.GetActorValue("SpeedMult"), "{0}%")
	else
		AddTextOptionST("SteedSpeedMult", "Trusty Steed's Speed", "", OPTION_FLAG_DISABLED)
	endif
	SetCursorPosition(6)
	AddHeaderOption("Advanced Options")
	AddSliderOptionST("SpeedMult", "Inigo's Speed", InigoRef.GetActorValue("SpeedMult"), "{0}%")
	AddSliderOptionST("CarryWeight", "Inigo's Carry Capacity", InigoRef.GetActorValue("CarryWeight"), "{0}")
	AddSliderOptionST("AttackDamageMult", "Inigo's Attack Damage", InigoRef.GetActorValue("AttackDamageMult")*100.0, "{0}%")
	AddSliderOptionST("DamageResist", "Inigo's Damage Resistance", InigoRef.GetActorValue("DamageResist"), "{0}")
	SetCursorPosition(7)
	AddHeaderOption("Emergency Use Only")
	AddTextOptionST("SummonInigoNow", "Summon Inigo Now", "")
	AddTextOptionST("SummonMrD", "Summon Mr Dragonfly", "")
	AddTextOptionST("RecoverBow", "Recover Inigo's Bow", "")
	AddTextOptionST("RecoverBooks", "Recover Inigo's Books", "")
	
	;-------------------------------renn
	if !InitMrD
		MrDVisible.OnInit()
		InitMrD = true
	endif
	
	GotoState("InigoChatState")
	OID_ = new int[20]
	SetCursorPosition(16)
	AddHeaderOption("NPC Chatting")
	OID_[2] = AddSliderOption("Chatting Rate", _10.GetValue(), "{0}%")
	OID_[4] = AddToggleOption("Remove Day Limitation", (1 - (_Day.GetValue() / 8)) as bool)	
	OID_[5] = AddToggleOption("Remove Moving Limitation", (1 - _IsMoving.GetValue()) as bool)	
	SetCursorPosition(17)
	AddHeaderOption("", 1)
	OID_[3] = AddSliderOption("Health Percentage", ((_HealthPercentage.GetValue() * 100) + 1), "more than {0}%")
;	OID_[1] = AddTextOption("Chatting Frequency: Max", "Do it")
	OID_[1] = AddTextOption("Chatting Frequency: Up", "Do it")
	OID_[0] = AddTextOption("Chatting Frequency: Reset", "Do it")
EndFunction

state InigoChatState

event OnOptionSelect(int option)
	if option == OID_[0]		;Reset
		if ShowMessage("Do you really want to reset current chatting settings?", true)
			_Day.SetValue(8)
			_10.SetValue(10)
			_15.SetValue(15)
			_20.SetValue(20)
			_30.SetValue(30)
			_50.SetValue(50)
			_HealthPercentage.SetValue(0.99)
			_IsMoving.SetValue(1)
			ForcePageReset()
		endif
;	elseif option == OID_[1]	;Max
;		_Day.SetValue(0)
;		_10.SetValue(100)
;		_15.SetValue(100)
;		_20.SetValue(100)
;		_30.SetValue(100)
;		_50.SetValue(100)
;		_HealthPercentage.SetValue(0.09)
;		_IsMoving.SetValue(0)
;		ForcePageReset()
	elseif option == OID_[1]	;Up
		_Day.SetValue(0)
		_10.SetValue(30)
		_15.SetValue(30)
		_20.SetValue(40)
		_30.SetValue(60)
		_50.SetValue(75)
		_HealthPercentage.SetValue(0.50)
		_IsMoving.SetValue(0)
		ForcePageReset()
	elseif option == OID_[4]	;Day Limitation
		if _Day.GetValue() == 8
			_Day.SetValue(0)
		else
			_Day.SetValue(8)
		endif
		SetToggleOptionValue(option, (1 - (_Day.GetValue() / 8)) as bool)
	elseif option == OID_[5]	;Moving Limitation
		_IsMoving.SetValue(1 - _IsMoving.GetValue())
		SetToggleOptionValue(option, (1 - _IsMoving.GetValue()) as bool)
	endif
endEvent

event OnOptionSliderOpen(int option)
	if option == OID_[2]		;Chatting Rate
        SetSliderDialogStartValue(_10.GetValue())
        SetSliderDialogDefaultValue(10)
        SetSliderDialogRange(0, 100)
        SetSliderDialoginterval(1)
	elseif option == OID_[3]	;Health Percentage
        SetSliderDialogStartValue((_HealthPercentage.GetValue() * 100) + 1)
        SetSliderDialogDefaultValue(100)
        SetSliderDialogRange(10, 100)
        SetSliderDialoginterval(1)
	endif
endEvent

event OnOptionSliderAccept(int option, float value)
	if option == OID_[2]
        SetSliderOptionValue(option, value, "{0}%")
		_10.SetValue(value)
		_15.SetValue(value + 5)
		_20.SetValue(value + 10)
		_30.SetValue(value + 20)
		_50.SetValue(value + 40)
		if _15.GetValue() > 100
			_15.SetValue(100)
		endif
		if _20.GetValue() > 100
			_20.SetValue(100)
		endif
		if _30.GetValue() > 100
			_30.SetValue(100)
		endif
		if _50.GetValue() > 100
			_50.SetValue(100)
		endif
	elseif option == OID_[3]
        SetSliderOptionValue(option, value, "more than {0}%")
		_HealthPercentage.SetValue((value - 1) / 100)
	endif
endEvent

event OnOptionHighlight(int option)
	if option == OID_[0]
		SetInfoText("Reset chatting configuration to default.")
	elseif option == OID_[1]
		SetInfoText("Set chatting configuration to maximum values.")
	elseif option == OID_[2]
		SetInfoText("Change the chatting rate.")
	elseif option == OID_[3]
		SetInfoText("Change the minimum health percentage for chatting.")
	elseif option == OID_[4]
		SetInfoText("If checked, Inigo will communicate with other followers every day.")
	elseif option == OID_[5]
		SetInfoText("If checked, Inigo will communicate with other followers whether moving or not.")
	endif
endEvent
	
endState

;-------------------------------


Function CloseMCM()
	int code = Input.GetMappedKey("Pause")
	while Utility.IsInMenuMode()
		Input.TapKey(code)
		Utility.WaitMenuMode(0.05)
	endwhile
EndFunction

State RecoverBooks

	Event OnHighlightST()
		SetInfoText("Recover Inigo's missing books.\n(They'll be added to his inventory not yours.)")
	EndEvent

	Event OnSelectST()
		SetOptionFlagsST(OPTION_FLAG_DISABLED)
		CloseMCM()
		Book it = Game.GetFormFromFile(0x000d77, "Inigo.esp") as Book
		if InigoRef.GetItemCount(it) < 1 && PlayerRef.GetItemCount(it) < 1
			InigoRef.AddItem(it, 1)
		endif
		it = Game.GetFormFromFile(0x02ecfe, "Inigo.esp") as Book
		if InigoRef.GetItemCount(it) < 1 && PlayerRef.GetItemCount(it) < 1
			InigoRef.AddItem(it, 1)
		endif
		if PlayerRef.HasSpell(Game.GetFormFromFile(0x0AA097, "Inigo.esp") as Spell)
			it = Game.GetFormFromFile(0x0ad12F, "Inigo.esp") as Book
			if InigoRef.GetItemCount(it) < 1 && PlayerRef.GetItemCount(it) < 1
				InigoRef.AddItem(it, 1)
			endif
		endif
		if (Game.GetFormFromFile(0x0695C5, "Inigo.esp") as Quest).IsStageDone(180)
			it = Game.GetFormFromFile(0x05dce1, "Inigo.esp") as Book
			if InigoRef.GetItemCount(it) < 1 && PlayerRef.GetItemCount(it) < 1
				InigoRef.AddItem(it, 1)
			endif
			it = Game.GetFormFromFile(0x05e245, "Inigo.esp") as Book
			if InigoRef.GetItemCount(it) < 1 && PlayerRef.GetItemCount(it) < 1
				InigoRef.AddItem(it, 1)
			endif
			it = Game.GetFormFromFile(0x05ed19, "Inigo.esp") as Book
			if InigoRef.GetItemCount(it) < 1 && PlayerRef.GetItemCount(it) < 1
				InigoRef.AddItem(it, 1)
			endif
		endif
	EndEvent

EndState


State RecoverBow

	Event OnHighlightST()
		SetInfoText("Recover Inigo's bow if you've lost it.\n(It will be added to his inventory not yours.)")
	EndEvent

	Event OnSelectST()
		SetOptionFlagsST(OPTION_FLAG_DISABLED)
		CloseMCM()
		Weapon Bow = Game.GetFormFromFile(0x02cc68, "Inigo.esp") as Weapon
		if InigoRef.GetItemCount(Bow) < 1 && PlayerRef.GetItemCount(Bow) < 1
			InigoRef.AddItem(Bow, 1)
			InigoRef.EquipItem(Bow)
		endif
	EndEvent

EndState


State SummonMrD

	Event OnHighlightST()
		SetInfoText("Summon Mr. Dragonfly to the player.")
	EndEvent

	Event OnSelectST()
		SetOptionFlagsST(OPTION_FLAG_DISABLED)
		CloseMCM()
		ObjectReference MrD = Game.GetFormFromFile(0x037538, "Inigo.esp") as ObjectReference
		MrD.MoveTo(PlayerRef, 80.0*Math.sin(PlayerRef.GetAngleZ()),  80.0*Math.cos(PlayerRef.GetAngleZ()), 10.0, 0)
	EndEvent

EndState


State SummonInigoNow

	Event OnHighlightST()
		SetInfoText("Bring Inigo to the player. This could break his quests!")
	EndEvent

	Event OnSelectST()
		SetOptionFlagsST(OPTION_FLAG_DISABLED)
		CloseMCM()
		float az = PlayerRef.GetAngleZ()
		InigoRef.MoveTo(PlayerRef, 80.0*Math.sin(az),  80.0*Math.cos(az), 10.0, 0)
		InigoRef.Disable()
		InigoRef.SetAngle(0, 0, az + 180)
		InigoRef.Enable()
	EndEvent

EndState


State AttackDamageMult

	Event OnHighlightST()
		SetInfoText("Inigo's Attack Damage compared to other NPCs. [default = 100%]")
	EndEvent

    Event OnSliderAcceptST(float value)
        InigoRef.ForceActorValue("AttackDamageMult", value/100.0)
        SetSliderOptionValueST(value)
    EndEvent

    Event OnSliderOpenST()
        SetSliderDialogStartValue(InigoRef.GetActorValue("AttackDamageMult")*100.0)
        SetSliderDialogDefaultValue(100.0)
        SetSliderDialogRange(10.0, 1000.0)
        SetSliderDialogInterval(10.0)
    EndEvent

EndState

State DamageResist

	Event OnHighlightST()
		SetInfoText("Inigo's Damage Resistance (including benefits from any armor he may be wearing). [default = 0]")
	EndEvent

    Event OnSliderAcceptST(float value)
        InigoRef.ForceActorValue("DamageResist", value)
        SetSliderOptionValueST(value)
    EndEvent

    Event OnSliderOpenST()
        SetSliderDialogStartValue(InigoRef.GetActorValue("DamageResist"))
        SetSliderDialogDefaultValue(0.0)
        SetSliderDialogRange(0.0, 1000.0)
        SetSliderDialogInterval(1.0)
    EndEvent

EndState

State CarryWeight

	Event OnHighlightST()
		SetInfoText("Inigo's current carry capcity (possibly modified by spells or enchantments). [default = 300]")
	EndEvent

    Event OnSliderAcceptST(float value)
        InigoRef.ForceActorValue("CarryWeight", value)
        SetSliderOptionValueST(value)
    EndEvent

    Event OnSliderOpenST()
        SetSliderDialogStartValue(InigoRef.GetActorValue("CarryWeight"))
        SetSliderDialogDefaultValue(300.0)
        SetSliderDialogRange(100.0, 3000.0) ;900
        SetSliderDialogInterval(5.0)
    EndEvent

EndState



State SpeedMult

	Event OnHighlightST()
		SetInfoText("Inigo's current speed compared to the game default speed for NPCs. [default = 115%]")
	EndEvent

    Event OnSliderAcceptST(float value)
        InigoRef.ForceActorValue("SpeedMult", value)
        SetSliderOptionValueST(value)
    EndEvent

    Event OnSliderOpenST()
        SetSliderDialogStartValue(InigoRef.GetActorValue("SpeedMult"))
        SetSliderDialogDefaultValue(115.0)
        SetSliderDialogRange(50.0, 200.0)
        SetSliderDialogInterval(5.0)
    EndEvent

EndState


State SteedSpeedMult

	Event OnHighlightST()
		SetInfoText("Inigo's steed's current speed compared to the game default speed for horses. [default = 100%]")
	EndEvent

    Event OnSliderAcceptST(float value)
        SteedRef.ForceActorValue("SpeedMult", value)
        SetSliderOptionValueST(value)
    EndEvent

    Event OnSliderOpenST()
        SetSliderDialogStartValue(SteedRef.GetActorValue("SpeedMult"))
        SetSliderDialogDefaultValue(100.0)
        SetSliderDialogRange(50.0, 300.0) ;200
        SetSliderDialogInterval(5.0)
    EndEvent

EndState


State SteedAllowed

	Event OnHighlightST()
		SetInfoText("Should Inigo be allowed to ride his trusty steed in this location?\nThis also summons or dismisses his current steed if possible.")
	EndEvent

	Event OnDefaultST()
		IsSteedAllowedHere = true
		OnSelectST()
	EndEvent

	Event OnSelectST()
		SetOptionFlagsST(OPTION_FLAG_DISABLED)
		CloseMCM()
		IsSteedAllowedHere = !IsSteedAllowedHere
		if CurrentWorld != Tamriel ; Riding is always allowed in Tamriel
			if IsSteedAllowedHere
				InigoStatus.Steed = "Allow"
			else
				InigoStatus.Steed = "Forbid"
			endif
		endif
		if SteedRef && !SteedRef.IsBeingRidden()
			if IsSteedAllowedHere || (CurrentWorld == Tamriel && PlayerRef.GetDistance(SteedRef) > 900)
				InigoStatus.Steed = "Summon"
			else
				InigoStatus.Steed = "Stable"
				InigoStatus.Steed = "Follow"
			endif
		endif
	EndEvent

EndState


State ShowMrD

	Event OnHighlightST()
		SetInfoText("Should Inigo wear Mr Dragonfly in a jar on his belt and if so how?\nOptions: No (the default), in a full-sized jar, in a small jar, and in a small jar in front")
	EndEvent

	Event OnSelectST()
		int pr = MrDVisible.ShowMrD + 1
		MrDVisible.ShowMrD = pr
		SetTextOptionValueST(ShowMrDTxt(pr))
	EndEvent

	Event OnDefaultST()
		MrDVisible.ShowMrD = 0
		SetTextOptionValueST(ShowMrDTxt(0))
	EndEvent

EndState

string Function ShowMrDTxt(int val)
	if val == 1
		return "Large Jar"
	elseif val == 2
		return "Small Jar"
	elseif val == 3
		return "Front Jar"
	else
		return "No"
	endif
EndFunction





State Whistle

	Event OnHighlightST()
		SetInfoText("After learning to Whistle to Inigo you can use this key instead of the power.")
	EndEvent

	Event OnDefaultST()
		OnKeyMapChangeST(45,"","") ; X is the default
	EndEvent

	Event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
		if keyCode == 1 || (keyCode > 255 && !Game.UsingGamepad())
			ShowMessage("$SKI_MSG1", false, "$OK", "$Cancel")
			return 
		endif
		UnregisterForKey(WhistleKeyCode)
		WhistleKeyCode = keyCode
		if WhistleKeyCode > 0
			RegisterForKey(WhistleKeyCode)
		endif
		SetKeyMapOptionValueST(WhistleKeyCode, false, "")
	EndEvent

EndState


Event OnKeyDown(int code)
	if code == WhistleKeyCode
		UnregisterForKey(WhistleKeyCode)
		if !WhistlePower ; fill these once
			WhistlePower = Game.GetFormFromFile(0x0AA097, "Inigo.esp") as Spell
			InigoRef = Game.GetFormFromFile(0x008ae9, "Inigo.esp") as Actor
			PlayerRef = Game.GetForm(0x14) as Actor
			;LocTypeInn = Keyword.GetKeyword("LocTypeInn") as Keyword
			;LocTypePlayerHouse = Keyword.GetKeyword("LocTypePlayerHouse") as Keyword
			;LangleyHouseIntLoc =  Game.GetFormFromFile(0x07FF4E, "Inigo.esp") as Location
			;InigoRelax1 = Game.GetFormFromFile(0x073496, "Inigo.esp") as Topic
			;InigoDialogueFollowerWaitTopic1 = Game.GetFormFromFile(0x04EA58, "Inigo.esp") as Topic
		endif

		if WhistlePower && PlayerRef.HasSpell(WhistlePower) && !Utility.IsInMenuMode() && Game.IsActivateControlsEnabled()
			ObjectReference ref = Game.GetCurrentCrosshairRef()
			if ref && (ref.GetBaseObject() as Furniture) && !InigoRef.GetCurrentScene() ; whistling at furniture
				int w = InigoRef.GetActorValue("WaitingForPlayer") as int
				if w == 1
					InigoRef.SetActorValue("WaitingForPlayer", 0)
				endif
				InigoRef.SetDoingFavor()
				ref.Activate(PlayerRef)
				Utility.Wait(0.2)
				while InigoRef.IsDoingFavor() && InigoRef.GetActorValue("WaitingForPlayer") != 1
					Utility.Wait(0.2)
				endwhile
				if InigoRef.IsDoingFavor()
					InigoRef.SetDoingFavor(false)
					if w < 0 || w > 1
						InigoRef.SetActorValue("WaitingForPlayer", w)
					endif
				endif
			else  ; otherwise standard whistle logic applies
				WhistlePower.Cast(PlayerRef, PlayerRef)
				Utility.Wait(2.0) ; need a little cool-down time
			endif
		endif
		RegisterForKey(WhistleKeyCode)
	endif
EndEvent


; cached values (could be filled as properties)
Actor InigoRef
Actor PlayerRef
Keyword LocTypeInn ; unused now
Keyword LocTypePlayerHouse ; unused now
Location LangleyHouseIntLoc ; unused now
Topic InigoRelax1 ; unused now
Topic InigoDialogueFollowerWaitTopic1 ; unused now
Spell WhistlePower  ; stop fighting power
FormList InigoSteedAllowed
InigoStatusQuestScript InigoStatus
Form Tamriel
MrDVisibleScript MrDVisible

; non-cached - dynamic values must be checked each time the MCM is opened
Form CurrentWorld
Actor SteedRef
bool IsSteedAllowedHere


; non-cached - long-term configuration value
int WhistleKeyCode

;------------------------------- renn

GlobalVariable Property _10 Auto
GlobalVariable Property _15 Auto
GlobalVariable Property _20 Auto
GlobalVariable Property _30 Auto
GlobalVariable Property _50 Auto
GlobalVariable Property _Day Auto ;8 = Default, 0 = All days
GlobalVariable Property _HealthPercentage Auto ;0.99
GlobalVariable Property _IsMoving Auto ;1 = Default(moving), 0 = Including none moving
int[] OID_
bool InitMrD

;-------------------------------